""" Password encryption. """

__version__ = "$Revision: 1.1 $"
# $Source: /home/vladap/src/mysqlUserFolder/RCS/passwords.py,v $
#
# $Author: vladap $
# $Date: 2002/12/26 11:34:56 $


PASSWD_ENC_LIST = [
	(0, 'Clear text'),
	(1, 'UNIX crypt'),
]

import random, crypt

# --------------------------------------------------------------------- */
# Interface functions.

def encode (password, type):
	if type == 0:
		return password

	elif type == 1:
		return pwe_crypt (password)

	else:
		raise 'Unknown password type: %s' % type


def check (password, enc_password, type):
	if type == 0:
		return (password == enc_password)

	elif type == 1:
	   return pwe_crypt_check (password, enc_password)

	else:
		raise 'Unknown password type: %s' % type


# --------------------------------------------------------------------- */
# Utility functions

def get_random_char ():
	c = random.randrange (ord ('a'), ord ('z') + 1)
	return chr (c)


# --------------------------------------------------------------------- */
# Specific crypto functions.

def pwe_crypt (password):
	salt = get_random_char () + get_random_char ()

	return crypt.crypt (password, salt)

def pwe_crypt_check (password, enc_password):
	salt = enc_password [:2]
	s = crypt.crypt (password, salt)

	return (s == enc_password)
	
	
	



